/*{
    "DESCRIPTION": "bw blobiscope",
    "CREDIT": "https://www.shadertoy.com/view/MsyyDy",
    "CATEGORIES": [
        "Your category"
    ],
    "INPUTS": [
    ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

#define SPEED 0.5
#define SHAPES 20.
#define SHARPNESS 2.5

// Multiple the result of this function call to rotate the coordinates by the given angle.
#define rotate(angle) mat2(cos(angle),-sin(angle), sin(angle),cos(angle));

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    // -1 to 1
    vec2 uv = ( 2.*fragCoord - iResolution.xy ) / iResolution.y;
    
    
    float mask = 0.;
    for (float i=0.; i < 6.; i += 1.) {
        uv *= rotate(iTime / 10.)
            
        float dx = length(uv.x);
        float dy = length(uv.y);

        mask += sin((dx - (iTime * float(SPEED))) * SHAPES) * SHARPNESS;
        mask += sin((dy - (iTime * float(SPEED))) * SHAPES / 2.) * SHARPNESS;

    }
    
    // Time varying pixel color
    vec3 col = vec3(mask);

    // Output to screen
    fragColor = vec4(col,1.0);
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}