/*{
    "DESCRIPTION": "bw-calling",
    "CREDIT": "https://www.shadertoy.com/view/3sG3zy",
    "CATEGORIES": [
        "Your category"
    ],
    "INPUTS": [
    ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

// Remake of "Calling" by Ojascki coded by Martijn Steinrucken aka BigWings - 2019
// countfrolic@gmail.com
// License Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
// 
// A quick and dirty remake of an effect by Ojascki
// https://www.facebook.com/ojasckI/photos/a.237033287121146/511096019714870/?type=3&theater


// Fabrice cleaned up my dirty code. Much nicer!
void mainImage( out vec4 O, vec2 u )
{
    vec2 R = iResolution.xy,
         U = ( u - .5*R ) / R.x;
    
    float a = iTime; a += sin(a*.5)*.25;
    U *= mat2(cos(a), -sin(a), sin(a), cos(a));

    a = 2. + sin(a*.4); 
    float x = atan(U.x, U.y)/6.283+.5,  
          y = 20./(9.*length(U)*a*a) - x;   
    x += ceil(y);
    y = fract(y)-.5;
    x = ( x*x*4.- sqrt(.25-y*y) )*3.;
    float w = fwidth(x),
          c = smoothstep(w, -w, abs(fract(x)-.5)-.25);
     
    O = vec4( (c-.5) *  max(0.,1.-w) +.5 );
}

// Original 'dirty' version
/* 
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = (fragCoord-.5*iResolution.xy)/iResolution.x;
    
    float a = iTime;
    a += sin(a*.5)*.25;
    uv *= mat2(cos(a), -sin(a), sin(a), cos(a));
    uv /= pow(length(uv*(6.+sin(a*.4)*3.)), 2.);
    
    vec3 col = vec3(0);
    
    float x = atan(uv.x, uv.y)/6.283+.5, x1=x, y = length(uv)*20.;
    
    x = x+floor(y-x)+1.;
    
    y = fract(y-x1)-.5;
    x = (x*x*4.-sqrt(.25-y*y))*3.;
    float w = fwidth(x);
    col += smoothstep(w, -w, abs(fract(x)-.5)-.25);
    
    col = (col-.5)*smoothstep(1., .0, w)+.5;
    

    fragColor = vec4(col,1.0);
}*/

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}