/*{
    "DESCRIPTION": "concentric hex lines",
    "CREDIT": "https://www.shadertoy.com/view/4tKXRV",
    "CATEGORIES": [
        "Your category"
    ],
    "INPUTS": [
    ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

#define PI     3.14159265358
#define TWO_PI (PI * 2.)

vec2 rotateCoord(vec2 uv, float rads) {
    uv *= mat2(cos(rads), sin(rads), -sin(rads), cos(rads));
    return uv;
}

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    float time = iTime * 1.;                                    // adjust time
    vec2 uv = (2. * fragCoord - iResolution.xy) / iResolution.y;    // center coordinates
    uv = rotateCoord(uv, PI * 0.25);
    float rads = atan(uv.x, uv.y);
    float vertices = 6.;
    float baseRadius = 0.7;
    float extraRadius = 0.03 + 0.03 * sin(time * 0.5);
    float curRadius = baseRadius + extraRadius * sin(rads * vertices);
    // vec2 edge = vec2(curRadius * sin(rads), curRadius * cos(rads));
    vec2 edge = curRadius* normalize(uv);
    float distFromCenter = length(uv);
    float distFromEdge = distance(edge, uv);
    float freq = 24.;
    if(distFromCenter > curRadius) freq *= 3.;
    float col = smoothstep(0.25, 0.75, abs(sin(time + distFromEdge * freq)));
    col += distFromCenter * 0.1;
    fragColor = vec4(col);
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}