/*{
  "DESCRIPTION": "first-fractal-attempt",
  "CREDIT": "https://www.shadertoy.com/view/ltlfRn",
  "CATEGORIES": [
    "Your category"
  ],
  "INPUTS": [
    {
      "LABEL": "Mouse X",
      "NAME": "mX",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse Y",
      "NAME": "mY",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse Z",
      "NAME": "mZ",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse W",
      "NAME": "mW",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    }
  ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;
vec4 iMouse = vec4(mX*RENDERSIZE.x, mY*RENDERSIZE.y, mZ*RENDERSIZE.x, mW*RENDERSIZE.y);

#define iters 30
#define tol 0.05

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    //vec2 c = (iMouse.xy/iResolution.xy - vec2(0.5))*2.;
    vec2 c = vec2(-0.25 + 0.17*cos(iTime/2.+1.5),-0.25 + 0.17*sin(iTime/2.+1.8));
  vec2 uv = (fragCoord.xy / iResolution.y - vec2(0.5*iResolution.x/iResolution.y, 0.5)).yx*1.5;
    
    int i;
    for (i=0; i<iters; i++) {
        uv = 0.5*abs(uv) / dot(uv, uv) + c;
    }
    //fragColor = dot(uv, uv) < tol ? vec4(1.) : vec4(0., 0., 0., 1.);
    fragColor = vec4(vec3(abs(dot(uv, uv) - tol)*2.), 1.0);
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}