/*{
	"DESCRIPTION": "psy-illusion",
	"CREDIT": "https://www.shadertoy.com/view/MsBGRR",
	"CATEGORIES": [
		"Your category"
	],
	"INPUTS": [
	],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

const float speed = 0.3;
const float gap = 0.02;

// map defines where the lines move forward and where they move backwards, based on the sign of the result.
float map(vec2 p)
{
	//return sin(atan(p.y, p.x)*5.0+length(p)*8.0);
	//return sin(atan(p.y, p.x)*8.0)-sin(length(p)*8.0);
	//return sin(p.x*8.0)*cos(p.y*8.0);
	//return sin(p.x*8.0);
	return sin(atan(p.y, p.x)+length(p)*8.0);
	//return -p.x;
}

// lmap defines the space the lines are in.
float lmap(vec2 p)
{
	//return length(p);
	//return atan(p.y, p.x)/6.28 + length(p);
	//return atan(p.y, p.x)/6.28 - length(p);
	//return abs(mod(p.x,0.1)-0.05) + p.y;
	return abs(mod(p.y,0.1)-0.05) + p.x;
	//return p.x;
}

float aaline(float x)
{
	return smoothstep(0.0, 0.1, x) * smoothstep(0.5, 0.6, 1.0-x);
}

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	vec2 uv = -1.0 + 2.0*fragCoord.xy / iResolution.xy;
	uv.x *= iResolution.x / iResolution.y;
	float f = map(uv);
	float l = lmap(uv);
	vec3 v = vec3(0.0);
	v += aaline(mod(l + iTime*speed*sign(f), 0.05)*20.0);
	v *= smoothstep(0.0, gap, abs(f));
	v *= smoothstep(0.0, 0.03, length(uv));
	v += vec3(1, 0, 0)*smoothstep(0.03, 0.0, length(uv));
	fragColor = vec4(v, 1.0) ;
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}