/*{
    "DESCRIPTION": "simple swarm",
    "CREDIT": "https://www.shadertoy.com/view/Xt3yR2",
    "CATEGORIES": [
        "Your category"
    ],
    "INPUTS": [
    ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

const float PI = 3.1415926535;
const float SC = 100.;
const int N = 7;
const float BOOST = 3.0;

mat2 rotate(float ang)
{
    float s = sin(ang);
    float c = cos(ang);
    return mat2(c, -s, s, c);
}

float patt(vec2 pos)
{
    return sin(SC * pos.x) * cos(SC * pos.y);
}

void mainImage(out vec4 fragColor, in vec2 fragCoord)
{
    float mx = max(iResolution.x, iResolution.y);
    vec2 uv = fragCoord / mx;

    float val = 0.0;
    mat2 rotN = rotate(PI / float(N)); 
    mat2 m = mat2(1.);
    for(int i=0; i<N; i++)
    {
        float sh = 0.01 * iTime * float(i);
        vec2 p = uv * m + vec2(sh);
        val += patt(p);
        m *= rotN;
    }
    val = BOOST * val / float(N);
    vec3 col = vec3(val);

    fragColor = vec4(col, 1.0);
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}