/*{
    "DESCRIPTION": "trippy2",
    "CREDIT": "https://www.shadertoy.com/view/XlSGDz",
    "CATEGORIES": [
        "Your category"
    ],
    "INPUTS": [
    ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;

vec2 rot(vec2 old, float ang) {
    ang = radians(ang);
    float c = cos(ang);
    float s = sin(ang);
    return vec2(c * old.x + s * old.y, -s * old.x + c * old.y);
}

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = fragCoord.xy / iResolution.xy * 2.0 - 1.0;
    uv.x *= iResolution.x / iResolution.y;
    
    float dir = step(0.0, length(uv) - 0.75) * 2.0 - 1.0;
    
    uv = rot(uv, iTime * 100.0);
    
    float b = smoothstep(-0.1, 0.1, cos(atan(uv.x, uv.y) * 10.0 + (length(uv) * -dir) * 75.0));
    
    fragColor = vec4(vec3(b), 1.0);
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}