/*{
  "DESCRIPTION": "zebrazebra",
  "CREDIT": "https://www.shadertoy.com/view/XscfzB",
  "CATEGORIES": [
    "Your category"
  ],
  "INPUTS": [
    {
      "LABEL": "Mouse X",
      "NAME": "mX",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse Y",
      "NAME": "mY",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse Z",
      "NAME": "mZ",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    },
    {
      "LABEL": "Mouse W",
      "NAME": "mW",
      "TYPE": "float",
      "DEFAULT": 0.5,
      "MIN": 0.0,
      "MAX": 1.0
    }
  ],
}*/

vec3 iResolution = vec3(RENDERSIZE, 1.);
float iTime = TIME;
vec4 iMouse = vec4(mX*RENDERSIZE.x, mY*RENDERSIZE.y, mZ*RENDERSIZE.x, mW*RENDERSIZE.y);

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = fragCoord/iResolution.y;
    float t = iTime*.004;
    vec2 center = vec2(iMouse/1000.0);
    float g = 3.1;
    center.x+=sin(uv.y*g+t+iTime);
    center.y+=cos(uv.x*g+t);
    float d = distance(uv,center);
  float k = -sin(d*6.283*10. - t);
  float e = smoothstep(0., fwidth(k)*1.5, k);
  fragColor = vec4(sqrt(max(e, 0.)));
}

void main(void) {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}